﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using KursiveWork;
using static LinkedList;

public class LinkedList
    {
        // Узел списка
        public class Node
        {
            public int Data { get; set; }
            public Node Next { get; set; }

            public Node(int data)
            {
                Data = data;
                Next = null;
            }
        }

        // Голова списка
        public Node head;

        // Конструктор
        public LinkedList()
        {
            head = null;
        }

        // Метод вставки элемента в начало списка
        public void InsertAtBeginning(int data)
        {
            Node newNode = new Node(data);
            newNode.Next = head;
            head = newNode;
        }

        // Метод поиска элемента по значению
        public bool Search(int data)
        {
            Node current = head;
            while (current != null)
            {
                if (current.Data == data)
                {
                    return true;
                }
                current = current.Next;
            }
            return false;
        }

        // Метод для создания объекта состояния списка
        public LinkedListState CreateState()
        {
            return new LinkedListState(this);
        }
        

        // Метод для возврата в определенное состояние
         public void RestoreState(LinkedListState state)
          {
               head = state.Head;
          }

        // Метод для выполнения шага операции
        public void PerformStep(LinkedListParameters parameters)
        {
            switch (parameters.Operation)
            {
                case LinkedListOperation.Insert:
                    InsertAtBeginning(parameters.Data);
                    break;
                case LinkedListOperation.Search:
                    // Для поиска в этом методе не требуется никаких действий, 
                    // так как поиск происходит в методе Search()
                    break;
            }
        }
}

