﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;



namespace KursiveWork;

// Класс-управленец для работы с односвязным списком
public class LinkedListManager
{
    private LinkedList list;
    public LinkedListStorage storage;
    private LinkedListParameters parameters;
        
    public LinkedListManager(LinkedListParameters parameters)
    {
        this.parameters = parameters;
        list = new LinkedList();
        storage = new LinkedListStorage();
    }

    // Метод для выполнения операции
    public LinkedListStorage PerformOperation()
    {
        // Создание начального состояния
        storage.AddState(list.CreateState()); 

        // Выполнение операции
        list.PerformStep(parameters); 

        // Создание конечного состояния
        storage.AddState(list.CreateState()); 

        return storage;
    }
}

