﻿
using static LinkedList;
using System;
using System.Drawing;
using static System.Runtime.InteropServices.JavaScript.JSType;
using System.Windows.Forms;

namespace KursiveWork;
// Класс-визуализатор состояния списка
public class LinkedListVisualizer
{
    private const int NodeWidth = 40;
    private const int NodeHeight = 30;
    private const int NodeSpacing = 20;

    // Метод визуализации состояния списка
    public Bitmap Visualize(LinkedListState state)
    {
        // Определение размера изображения
        int width = NodeWidth * 10 + NodeSpacing * 9;
        int height = NodeHeight + 200;
        Bitmap bitmap = new Bitmap(width, height);
        using (Graphics g = Graphics.FromImage(bitmap))
        {
            // Заливка фона
            g.Clear(Color.White);
            //Отрисовка головы
            g.DrawString("Head", new Font("Arial", 12), Brushes.Black, new Point(10, 15));
            g.DrawLine(Pens.Black, 55, 25, 20 + NodeWidth + NodeSpacing, 25);
            g.DrawPolygon(Pens.Black, new Point[] {
                            new Point(28 + NodeWidth + NodeSpacing, 25),
                            new Point(28 + NodeWidth + NodeSpacing - 5, 20),
                            new Point(28 + NodeWidth + NodeSpacing - 5, 30)
                        });
            // Рисование узлов
            Node current = state.Head;
            int x = 70 + NodeSpacing;
            
            while (current != null)
            {
                // Рисование узла
                g.FillEllipse(Brushes.LightBlue, x, 10, NodeWidth, NodeHeight);
                g.DrawString(current.Data.ToString(), new Font("Arial", 12), Brushes.Black, new Point(x + NodeWidth / 2 - 5, 15));


                VisualizeAdd(x);




                // Рисование стрелки
                if (current.Next != null)
                {
                    g.DrawLine(Pens.Black, x + NodeWidth, 25, x + NodeWidth + NodeSpacing - 7, 25);
                    g.DrawPolygon(Pens.Black, new Point[] {
                            new Point(x + NodeWidth + NodeSpacing, 25),
                            new Point(x + NodeWidth + NodeSpacing - 5, 20),
                            new Point(x + NodeWidth + NodeSpacing - 5, 30)
                        });
                }
                else
                {
                    g.DrawLine(Pens.Black, x + NodeWidth, 25, x + NodeWidth + NodeSpacing - 7, 25);
                    g.DrawPolygon(Pens.Black, new Point[] {
                            new Point(x + NodeWidth + NodeSpacing, 25),
                            new Point(x + NodeWidth + NodeSpacing - 5, 20),
                            new Point(x + NodeWidth + NodeSpacing - 5, 30)
                        });
                }

                x += NodeWidth + NodeSpacing;
                current = current.Next;
            }
            if (current == null)
            {
                g.DrawString("NULL", new Font("Arial", 12), Brushes.Black, new Point(x + NodeWidth / 2 - 15, 15));
            }
        }
        return bitmap;
    }
    public void VisualizeAdd(int Number)
    {
        int width = NodeWidth * 10 + NodeSpacing * 9;
        int height = NodeHeight + 200;
        Bitmap bitmap = new Bitmap(width, height);
        using (Graphics g = Graphics.FromImage(bitmap))
        {
            g.FillEllipse(Brushes.LightBlue, 50, 50, 40, 30);
            g.DrawString(Number.ToString(), new Font("Arial", 12), Brushes.Black, new Point(50, 55));
        }
    }
}
